cls
color 15
locate 5 , 15 : color 15
print "Send formatted binary commands to Jupiter GPS Rx"

open "com1:9600,N,8,1, ds, cs" as 1 len = 32000

do
	print #1 , chr$(&H40,&H40,&H57,&H62,&H01,&H34,&H0D,&H0A)
	incr iter% : print iter%;
	delay .3
	if loc(1) then line input #1, l$
loop until instr(l$ , "@@") > 0

color 10 : print " Set to NAV Format" : color 7

header% = &h81FF              											'WORD (1)

do
	for rw% = 2 to 13
		locate rw% , 1
		print space$(80)
	next

	locate 6 , 1
	print "Any key to continue"
	do									'Allows interrupt responses to be processed
		if l$ > "" then print l$
	loop until inkey$ > ""

	locate 6 , 1 : print space$(20)
	locate 8 , 5 : color 7
	input "Command Number / Msg ID.  (decimal)   ",cmdno%
	if cmdno% = 0 then locate 24, 1 : end								'WORD (2)

	
	locate 8 , 59 : color 14
	print cmdno%
	color 7
	locate 10 , 1 : print space$(80)
   locate 11 , 1 : print space$(80)

   flags% = &b00000000000000	'DCL0 QRAN 00xxxxxx'
	locate 10 , 5
	print "Flags - Disconnect Connect Logging Query Request Ack Nak  D/C/L/Q/R/A/N"
	print tab(10);"[rtn] to end    ";
	color 14
	do
		while not instat : wend
		ik$ = ucase$(inkey$)
		posik% = instr("DCL.QRAN", any ik$)
		if posik% then
			if ik$ = "." then iterate loop
			bitno% = 16 - posik%
			bit set flags% , bitno%
			print ik$;
		end if
	loop until ik$ = chr$(13)
	locate 11 , 60
	flags% = flags% + cmdcount%
	print bin$(flags%)														'WORD (4)
	color 7

	datacount% = 0
	locate 13 , 5
	print "Input data items  (decimal)    [rtn] alone  to end"
	datacount% = 0
	do
		locate 13 , 60
		print space$(20)
		locate 13 , 60
		print using "Item ## ";datacount% + 1;
		input, n$
		if n$ = "" then exit loop
		datafield%(datacount%) = val(n$)									'WORDS (6)-(n)
		incr datacount%														'WORD (3)
	loop

'Now calculate header checksum
	hdrchk& = 0
	hdrchk& = (header% + cmdno%) AND &hFFFF
	hdrchk& = (hdrchk& + datacount%) AND &hFFFF
	hdrchk& = (hdrchk& + flags%) AND &hFFFF							'WORD (5)
	if hdrchk& <> &h8000 then hdrchk& = -hdrchk&
	hdrchk% = hdrchk&


'Now calculate data checksum

	datachk& = 0
	if datacount% then
		for i% = 0 to datacount%
			datachk& = (datachk& + datafield%(i%)) AND &hFFFF
		next i%
		datachk& = datachk& AND &hFFFF

		if datachk& <> &h8000 then datachk& = -datachk&				'WORD (n+1)
		datachk% = datachk&
	end if


	color 13 : locate 20 , 1
	print hex$(header%) + " " + hex$(cmdno%) + " " + hex$(datacount%) + _
			" " + hex$(flags%) + " " + hex$(hdrchk&) + "    ";

	if datacount% then
		for i% = 0 to datacount% - 1
			print hex$(datafield%(i%)) + " " ;
		next i%
		print hex$(datachk&)
	end if

	color 12 : locate 21,1

	call  SendWord(header%)
	call  SendWord(cmdno%)
	call  SendWord(datacount%)
	call  SendWord(flags%)
	call  SendWord(hdrchk%)

	if datacount% then
	color 10 : print " Data "; : color 12
		for i% = 0 to datacount% - 1
			call SendWord(datafield%(i%))
		next i%
		call	SendWord(datachk%)
	end if
	for yy% = 1 to 10
		delay .054
	next yy%
	print
	cmdcount% = (cmdcount% + 1) mod 64
loop
locate 23, 1
end



sub SendWord(x%)
	blo% = x% AND &hFF
	bhi% = x%
	shift right bhi%, 8
	bhi% = bhi% AND &hFF

	print #1 , chr$(blo%);		'word sent  low byte / high byte
	print #1 , chr$(bhi%);
end sub

ReadCom:
	p% = loc(1)
	l$ = l$ + input$ (p% , 1)
	locate 23 , 1 : print space$(80)
	color 9

	for x% = 1 to len(l$)
'		locate 23 , x% * 4
		print hex$(asc(mid$(l$ , x% , 1))) + " ";
	next x%
	delay .5
	l$ = ""
return
